/**
* @file main.c
*
* Copyright (c) 2006 Atmel.
*
* @brief {͎喳JԂ񋟂܂B\n
* グ菇𐶐AĒJԂUART߉ߕĂяo܂B
* @version 1.0 (CVS revision : $Revision: 1.4 $)
* @date $Date: 2006/07/12 12:58:27 $
* @author $Author: raubree $
*****************************************************************************/
#include "config.h"
#include "config_motor.h"

#include "mc_interface.h"
#include "mc_control.h"
#include "mc_drv.h"
#include "ushell_task.h"

#include "adc\adc_drv.h"
#include "comparator\comparator_drv.h"

U16 g_regulation_period = 0;		//!< ̎`
U16 g_speed_monitor_period = 0;
extern Bool g_tick;					// ̎掞ԂɎgpAmc_drv.cB
Bool ramp_up = FALSE;

  U8 tick_divider;
  U8 new_position = HS_001;			// グ菇ɑ΂Cӂ̉]qʒu
  U8 tick_divider_min = 50;
  U8 ramp_counter = 0;


void mc_ramp_up_init(void)
{
  ramp_counter = 0;
  tick_divider_min = 50;
  new_position = HS_001;
  ramp_up = TRUE;
  g_speed_monitor_period = 0;
}


void main(void)
{
  ushell_task_init();

  // d@
  mc_motor_init();								// d@̏Jn

  while(1)
  {
	// ߓdɏ]PSCԂ\
	if(PCTL2 & (1<<PRUN2))  switch_OFF_LED();	// PSC ONLED
	else  switch_ON_LED();						// PSC OFFLED_(ߓd)

	// JԂJn
	// v1S250sŊ荞(g_tick)𐶐܂B
	// ̎=n~250s
	if (g_tick == TRUE)
	{
	  g_tick = FALSE;
	  // dƉϒR̒l擾
	  mc_ADC_Scheduler();
	  if (ramp_up == TRUE)
	  {
		/* グ菇Jn */
		Disable_comparator0_interrupt();	// BEMF荞݋֎~
		Disable_comparator1_interrupt();	// BEMF荞݋֎~
		Disable_comparator2_interrupt();	// BEMF荞݋֎~
		ramp_counter += 1;
		if ( ramp_counter >= 40 )
		{
		  ramp_counter = 0;
		  if (tick_divider_min > 3)
		  {
			tick_divider_min -= 1;
		  }
		  else
		  {
			ramp_up = FALSE;
			g_speed_monitor_period = 1;
//			mc_set_Speed_Loop();			// xJԂ
			mc_set_Open_Loop();				// JԂȂ
			mci_set_motor_speed(180);
			mc_regulation_loop();
			Enable_comparator0_interrupt();	// BEMF荞݋
			Enable_comparator1_interrupt();	// BEMF荞݋
			Enable_comparator2_interrupt();	// BEMF荞݋
		  }
		}
		tick_divider += 1;
		if ( tick_divider >= tick_divider_min )
		{
		  tick_divider = 0;
		  if (mci_get_motor_direction()==CCW)
		  {
			switch(new_position)
			{
			  /* CCWグ */
			  case HS_001:
				new_position = HS_011;
				break;
			  case HS_101:
				new_position = HS_001;
				break;
			  case HS_100:
				new_position = HS_101;
				break;
			  case HS_110:
				new_position = HS_100;
				break;
			  case HS_010:
				new_position = HS_110;
				break;
			  case HS_011:
				new_position = HS_010;
				break;
			  default :
				new_position = HS_001;
				break;
			}
		  }
		  else
		  {
			switch(new_position)
			{
			  /* CWグ */
			  case HS_001:
				new_position = HS_101;
				break;
			  case HS_101:
				new_position = HS_100;
				break;
			  case HS_100:
				new_position = HS_110;
				break;
			  case HS_110:
				new_position = HS_010;
				break;
			  case HS_010:
				new_position = HS_011;
				break;
			  case HS_011:
				new_position = HS_001;
				break;
			  default :
				new_position = HS_001;
				break;
			}
		  }
		  mc_switch_commutation(new_position);
		}
		/* グ菇I */
	  }

	  g_regulation_period += 1;
	  if ( g_regulation_period >= 8 )			// n~250s=Te:2ms
	  {
		g_regulation_period = 1;
		mc_regulation_loop();					// JԂJn
	  }

	  /* xĎ */
	  if (mci_run_stop == RUN)
	  {
		g_speed_monitor_period += 1;
		if ( g_speed_monitor_period >= 4000 )	// n~250s=1s
		{
		  g_speed_monitor_period = 1;
		  if (mci_get_measured_speed() > 250) mc_ramp_up_init();
		  if (mci_get_measured_speed() < (100/27)) mc_ramp_up_init();
		}
	  }

	  /* UARTʐMĎ */
	  ushell_task();

	}
  }
}
